<table class="table table-hover table-sm table-responsive" id="isaric-h12o-model-table" style="display: table;">
  <thead class="thead-light">
    <tr>
      <th>+/-</th>
      <th scope="col">{{ i18n "component" }}</th>
      <th scope="col">{{ i18n "description" }}</th>
      <th scope="col">{{ i18n "context" }}</th>
      <th scope="col">{{ i18n "standard" }}</th>
      <th scope="col">{{ i18n "code" }}</th>
    </tr>
  </thead>
  <tbody>
    {{ range $index, $cluster := $.Site.Data.c19dpes_hv_isaric_12o_model.clusters }}
    {{ $clusterScope := . }}
    <tr class="cluster">
      <td><i id="scope-{{ .code }}" class="bi bi-plus-circle-fill dp-color--primary"></i></td>
      <td>{{ .component }}</td>
      <td>{{ .description }}</td>
      <td>{{ .context }}</td>
      <td>{{ .standard }}</td>
      <td>{{ .code }}</td>
    </tr>
    {{ range $index, $variable := .variables }}
    {{ $variableScope := . }}
    <tr class="variable d-none" name="scope-{{ $clusterScope.code }}">
      <td><i id="scope-{{ .code }}" class="bi bi-plus-circle-fill dp-color--blue--light"></i></td>
      <td>{{ .component }}</td>
      <td>{{ .description }}</td>
      <td>{{ .context }}</td>
      <td>{{ .standard }}</td>
      <td>{{ .code }}</td>
    </tr>
    {{ range $index, $value := .values }}
    {{ $valueScope := . }}
    <tr class="value d-none" name="scope-{{ $variableScope.code }}">
      <td></td>
      <td>{{ .component }}</td>
      <td>{{ .description }}</td>
      <td>{{ .context }}</td>
      <td>{{ .standard }}</td>
      <td>{{ .code }}</td>
    </tr>
    {{ end }}
    {{ end }}
    {{ end }}
  </tbody>
</table>

<script>
  $(function () {

    // Expand and collapse rows.
    const clickableRows = $('.cluster, .variable');
    const nonClickableRows = document.querySelectorAll('.value');
    clickableRows.on('click', function (e) {
      e.preventDefault();
      const clickedRow = this;
      const code = clickedRow.cells[5].innerText;
      const scopeId = `scope-${code}`;
      const isCluster = clickedRow.classList.contains('cluster');
      const iconButton = document.querySelector(`#${scopeId}`);
      const shouldExpand = iconButton.classList.contains('bi-plus-circle-fill');
      const shouldCollapse = iconButton.classList.contains('bi-dash-circle-fill');
      const subRows = document.querySelectorAll(`tr[name=${scopeId}]`);
      if (shouldExpand) {
        iconButton.classList.replace('bi-plus-circle-fill', 'bi-dash-circle-fill');
        for (const row of subRows) row.classList.remove('d-none');
      } else if (shouldCollapse) {
        iconButton.classList.replace('bi-dash-circle-fill', 'bi-plus-circle-fill');
        for (const row of subRows) row.classList.add('d-none');
        if (isCluster) {

          for (const row of nonClickableRows) row.classList.add('d-none');
        }
      }
    });
  });

  $(document).ready(() => {
    const isaricH12oModelTable = $('#isaric-h12o-model-table').DataTable({
      dom: `
        <".container-fluid"
          <".row my-2"
            <".mr-auto"i>
            <"#search-1.mr-2"f>
          >
          <".row"t>
          <".row"
            <".mr-auto"l>
            <".ml-auto"p>
          >
        >
      `,
      ordering: false,
      paging: false,
    });

    // Move download button next to filter search box.
    const downloadButtonIsaric = document.querySelector('#download-button-1');
    const searchIsaric = document.querySelector('#search-1');
    searchIsaric.insertAdjacentElement('afterend', downloadButtonIsaric);
  });
</script>
